diff -r e16bdc0054ce src/road_gui.cpp
--- a/src/road_gui.cpp
+++ b/src/road_gui.cpp
@@ -1,4 +1,4 @@
-/* $Id: road_gui.cpp 27381 2015-08-10 20:24:13Z michi_cc $ */
+/* $Id: road_gui.cpp 27163 2015-02-22 15:26:27Z frosch $ */
 
 /*
  * This file is part of OpenTTD.
@@ -11,7 +11,9 @@
 
 #include "stdafx.h"
 #include "gui.h"
+#include "cmd_helper.h"
 #include "window_gui.h"
+#include "station_func.h"
 #include "station_gui.h"
 #include "terraform_gui.h"
 #include "viewport_func.h"
@@ -29,7 +31,7 @@
 #include "hotkeys.h"
 #include "road_gui.h"
 #include "zoom_func.h"
-
+#include "industry.h"
 #include "widgets/road_widget.h"
 
 #include "table/strings.h"
@@ -211,6 +213,107 @@
 	}
 }
 
+
+static RoadBits FindRoadsToConnect(TileIndex tile) {
+	RoadBits bits = ROAD_NONE;
+	DiagDirection ddir;
+	// Prioritize roadbits that head in this direction
+	for (ddir = DIAGDIR_BEGIN; ddir < DIAGDIR_END; ddir++) {
+		TileIndex cur_tile = TileAddByDiagDir(tile, ddir);
+		if (GetAnyRoadBits(cur_tile, ROADTYPE_ROAD, true) &
+			DiagDirToRoadBits(ReverseDiagDir(ddir)))
+		{
+			bits |= DiagDirToRoadBits(ddir);
+		}
+	}
+	if (bits != ROAD_NONE) {
+		return bits;
+	}
+	// Try to connect to any road passing by
+	for (ddir = DIAGDIR_BEGIN; ddir < DIAGDIR_END; ddir++) {
+		TileIndex cur_tile = TileAddByDiagDir(tile, ddir);
+		if (HasTileRoadType(cur_tile, ROADTYPE_ROAD) && (GetTileType(cur_tile) == MP_ROAD) &&
+				(GetRoadTileType(cur_tile) == ROAD_TILE_NORMAL)) {
+			bits |= DiagDirToRoadBits(ddir);
+		}
+	}
+	return bits;
+}
+
+static DiagDirection RoadBitsToDiagDir(RoadBits bits) {
+	if (bits < ROAD_SE) {
+		return bits == ROAD_NW ? DIAGDIR_NW : DIAGDIR_SW;
+	}
+	return bits == ROAD_SE ? DIAGDIR_SE : DIAGDIR_NE;
+}
+
+static DiagDirection TileFractCoordsToDiagDir() {
+	bool diag = (_tile_fract_coords.x + _tile_fract_coords.y) < 16;
+	if (_tile_fract_coords.x < _tile_fract_coords.y) {
+		return diag ? DIAGDIR_NE : DIAGDIR_SE;
+	}
+	return diag ? DIAGDIR_NW : DIAGDIR_SW;
+}
+/*
+ * Selects orientation for road object (depot, terminal station)
+ */
+static DiagDirection AutodetectRoadObjectDirection(TileIndex tile) {
+	RoadBits bits = FindRoadsToConnect(tile);
+	if (HasExactlyOneBit(bits)) {
+		return RoadBitsToDiagDir(bits);
+	}
+	if (bits == ROAD_NONE){
+		bits = ROAD_ALL;
+	}
+	RoadBits frac_bits = DiagDirToRoadBits(TileFractCoordsToDiagDir());
+	if (HasExactlyOneBit(frac_bits & bits)) {
+		return RoadBitsToDiagDir(frac_bits & bits);
+	}
+	frac_bits |= MirrorRoadBits(frac_bits);
+	if (HasExactlyOneBit(frac_bits & bits)) {
+		return RoadBitsToDiagDir(frac_bits & bits);
+	}
+	for (DiagDirection ddir = DIAGDIR_BEGIN; ddir < DIAGDIR_END; ddir++) {
+		if (DiagDirToRoadBits(ddir) & bits) {
+			return ddir;
+		}
+	}
+	NOT_REACHED();
+}
+
+static bool CheckDriveThroughRoadStopDirection(TileArea area, RoadBits r) {
+	TILE_AREA_LOOP(tile, area) {
+		if (!HasTileRoadType(tile, ROADTYPE_ROAD)) continue;
+		if (GetTileType(tile) != MP_ROAD) continue;
+		if (GetRoadTileType(tile) != ROAD_TILE_NORMAL) continue;
+		if (GetRoadBits(tile, ROADTYPE_ROAD) & ~r) return false;
+	}
+	return true;
+}
+
+
+/*
+ * Automaticaly selects direction to use for road stop.
+ * @param area road stop area
+ * @return selected direction
+ */
+static DiagDirection AutodetectDriveThroughRoadStopDirection(TileArea area) {
+	bool se_suits, ne_suits;
+
+	// Check which direction is available
+	// If both are not use SE, building will fail anyway
+	se_suits = CheckDriveThroughRoadStopDirection(area, ROAD_Y);
+	ne_suits = CheckDriveThroughRoadStopDirection(area, ROAD_X);
+	if (!ne_suits) return DIAGDIR_SE;
+	if (!se_suits) return DIAGDIR_NE;
+
+	// Build station along the longer direction
+	if (area.w > area.h) return DIAGDIR_NE;
+	if (area.w < area.h) return DIAGDIR_SE;
+
+	return AutodetectRoadObjectDirection(area.tile);
+}
+
 /**
  * Place a new road stop.
  * @param start_tile First tile of the area.
@@ -225,14 +328,23 @@
 {
 	uint8 ddir = _road_station_picker_orientation;
 	SB(p2, 16, 16, INVALID_STATION); // no station to join
+	TileArea ta(start_tile, end_tile);
 
 	if (ddir >= DIAGDIR_END) {
-		SetBit(p2, 1); // It's a drive-through stop.
-		ddir -= DIAGDIR_END; // Adjust picker result to actual direction.
+		if (ddir < DIAGDIR_END + 2) {
+			SetBit(p2, 1); // It's a drive-through stop.
+			ddir -= DIAGDIR_END; // Adjust picker result to actual direction.
+		}
+		else if (ddir == DIAGDIR_END + 2) {
+			ddir = AutodetectRoadObjectDirection(start_tile);
+		}
+		else if (ddir == DIAGDIR_END + 3) {
+			SetBit(p2, 1); // It's a drive-through stop.
+			ddir = AutodetectDriveThroughRoadStopDirection(ta);
+		}
 	}
 	p2 |= ddir << 6; // Set the DiagDirecion into p2 bits 6 and 7.
 
-	TileArea ta(start_tile, end_tile);
 	CommandContainer cmdcont = { ta.tile, (uint32)(ta.w | ta.h << 8), p2, cmd, CcRoadStop, "" };
 	ShowSelectStationIfNeeded(cmdcont, ta);
 }
@@ -297,8 +409,8 @@
 	if (w->IsWidgetDisabled(WID_ROT_REMOVE)) return false;
 
 	/* allow ctrl to switch remove mode only for these widgets */
-	for (uint i = WID_ROT_ROAD_X; i <= WID_ROT_AUTOROAD; i++) {
-		if (w->IsWidgetLowered(i)) {
+	for (uint i = WID_ROT_ROAD_X; i <= WID_ROT_FULLROAD; i++) {
+		if (w->GetWidget<NWidgetCore>(i) && w->IsWidgetLowered(i)) {
 			ToggleRoadButton_Remove(w);
 			return true;
 		}
@@ -382,6 +494,7 @@
 			case WID_ROT_ROAD_X:
 			case WID_ROT_ROAD_Y:
 			case WID_ROT_AUTOROAD:
+			case WID_ROT_FULLROAD:
 				this->SetWidgetsDisabledState(!this->IsWidgetLowered(clicked_widget),
 						WID_ROT_REMOVE,
 						WID_ROT_ONE_WAY,
@@ -403,8 +516,19 @@
 		}
 	}
 
+	virtual void DrawWidget(const Rect &r, int widget) const
+	{
+		if (widget == WID_ROT_FULLROAD) {
+			Dimension d = GetSpriteSize(SPR_BLOT);
+			uint offset = this->IsWidgetLowered(WID_ROT_FULLROAD) ? 1 : 0;
+			DrawSprite(SPR_BLOT, PALETTE_TO_GREY, (r.left + r.right - d.width) / 2 + offset, (r.top + r.bottom - d.height) / 2 + offset);
+		}
+	}
+
+
 	virtual void OnClick(Point pt, int widget, int click_count)
 	{
+		static bool fullroad_warned = false;
 		_remove_button_clicked = false;
 		_one_way_button_clicked = false;
 		switch (widget) {
@@ -423,6 +547,16 @@
 				this->last_started_action = widget;
 				break;
 
+			case WID_ROT_FULLROAD:
+				HandlePlacePushButton(this, WID_ROT_FULLROAD, _road_type_infos[_cur_roadtype].cursor_autoroad, HT_RECT);
+				if (!fullroad_warned) {
+					ShowGoalQuestion(0, 2 /* WARNING */, 2 /* OK */, "Full-tile autoroad tool is deprecated and will be removed in next release.\n Use regular autoroad tool instead.");
+					fullroad_warned = true;
+				}
+
+				this->last_started_action = widget;
+				break;
+
 			case WID_ROT_DEMOLISH:
 				HandlePlacePushButton(this, WID_ROT_DEMOLISH, ANIMCURSOR_DEMOLISH, HT_RECT | HT_DIAGONAL);
 				this->last_started_action = widget;
@@ -491,6 +625,7 @@
 
 	virtual void OnPlaceObject(Point pt, TileIndex tile)
 	{
+		DiagDirection ddir;
 		_remove_button_clicked = this->IsWidgetLowered(WID_ROT_REMOVE);
 		_one_way_button_clicked = this->IsWidgetLowered(WID_ROT_ONE_WAY);
 		switch (this->last_started_action) {
@@ -513,12 +648,23 @@
 				VpStartPlaceSizing(tile, VPM_X_OR_Y, DDSP_PLACE_AUTOROAD);
 				break;
 
+			case WID_ROT_FULLROAD:
+				_place_road_flag = RF_NONE;
+				if (_tile_fract_coords.x >= 8) _place_road_flag |= RF_START_HALFROAD_X;
+				if (_tile_fract_coords.y >= 8) _place_road_flag |= RF_START_HALFROAD_Y;
+				VpStartPlaceSizing(tile, VPM_X_OR_Y, DDSP_PLACE_FULLROAD);
+				break;
+
 			case WID_ROT_DEMOLISH:
 				PlaceProc_DemolishArea(tile);
 				break;
 
 			case WID_ROT_DEPOT:
-				DoCommandP(tile, _cur_roadtype << 2 | _road_depot_orientation, 0,
+				ddir = _road_depot_orientation;
+				if (ddir == DIAGDIR_NW + 1) {
+					ddir = AutodetectRoadObjectDirection(tile);
+				}
+				DoCommandP(tile, _cur_roadtype << 2 | ddir, 0,
 						CMD_BUILD_ROAD_DEPOT | CMD_MSG(_road_type_infos[_cur_roadtype].err_depot), CcRoadDepot);
 				break;
 
@@ -578,6 +724,7 @@
 				break;
 
 			case DDSP_PLACE_AUTOROAD:
+			case DDSP_PLACE_FULLROAD:
 				_place_road_flag &= ~(RF_END_HALFROAD_Y | RF_END_HALFROAD_X);
 				if (pt.y & 8) _place_road_flag |= RF_END_HALFROAD_Y;
 				if (pt.x & 8) _place_road_flag |= RF_END_HALFROAD_X;
@@ -603,6 +750,20 @@
 		VpSelectTilesWithMethod(pt.x, pt.y, select_method);
 	}
 
+	void TryToRemoveExtraRoadBits(TileIndex tile, RoadBits &rb) {
+		for (DiagDirection dir = DIAGDIR_BEGIN; dir != DIAGDIR_END; dir++) {
+			RoadBits dir_rb = DiagDirToRoadBits(dir);
+			if (!(rb & dir_rb)) continue;
+			if (CanConnectToRoad(tile, _cur_roadtype, dir)) continue;
+			DoCommandP(tile, tile,
+			    (dir_rb == ROAD_NW || dir_rb == ROAD_NE ? 0 : 3) |
+			    (dir_rb & ROAD_X ? 0 : 4) |
+			    (_cur_roadtype << 3),
+			    CMD_REMOVE_LONG_ROAD);
+			rb &= ~dir_rb;
+		}
+	}
+
 	virtual void OnPlaceMouseUp(ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
 	{
 		if (pt.x != -1) {
@@ -632,6 +793,30 @@
 							CMD_BUILD_LONG_ROAD | CMD_MSG(_road_type_infos[_cur_roadtype].err_build_road), CcPlaySound1D);
 					break;
 
+				case DDSP_PLACE_FULLROAD:
+					if (start_tile == end_tile || _remove_button_clicked) {
+						_place_road_flag = (RoadFlags)((_place_road_flag & RF_DIR_Y) ? (_place_road_flag & 0x07) : (_place_road_flag >> 3));
+						DoCommandP(start_tile, end_tile, _place_road_flag | (_cur_roadtype << 3) | (_one_way_button_clicked << 5),
+							_remove_button_clicked ?
+							CMD_REMOVE_LONG_ROAD | CMD_MSG(_road_type_infos[_cur_roadtype].err_remove_road) :
+							CMD_BUILD_LONG_ROAD | CMD_MSG(_road_type_infos[_cur_roadtype].err_build_road), CcPlaySound1D);
+					} else {
+						_place_road_flag &= RF_DIR_Y;
+						RoadBits road_dir = _place_road_flag ? ROAD_Y : ROAD_X;
+						// if (start_tile > end_tile) Swap(start_tile, end_tile);
+						RoadBits start_extra_rb = GetAnyRoadBits(start_tile, _cur_roadtype, false) & ~road_dir;
+						RoadBits end_extra_rb = GetAnyRoadBits(end_tile, _cur_roadtype, false) & ~road_dir;
+						this->TryToRemoveExtraRoadBits(start_tile, start_extra_rb);
+						this->TryToRemoveExtraRoadBits(end_tile, end_extra_rb);
+						if ((bool)start_extra_rb != (start_tile > end_tile)) _place_road_flag |= RF_START_HALFROAD_Y;
+						if (!end_extra_rb != (start_tile > end_tile)) _place_road_flag |= RF_END_HALFROAD_Y;
+						DoCommandP(start_tile, end_tile,
+							_place_road_flag | (_cur_roadtype << 3) |
+							(_one_way_button_clicked << 5) | (1 << 6),
+							CMD_BUILD_LONG_ROAD | CMD_MSG(_road_type_infos[_cur_roadtype].err_build_road), CcPlaySound1D);
+					}
+					break;
+
 				case DDSP_BUILD_BUSSTOP:
 					PlaceRoadStop(start_tile, end_tile, (_ctrl_pressed << 5) | RoadTypeToRoadTypes(_cur_roadtype) << 2 | ROADSTOP_BUS, CMD_BUILD_ROAD_STOP | CMD_MSG(_road_type_infos[_cur_roadtype].err_build_station[ROADSTOP_BUS]));
 					break;
@@ -642,13 +827,13 @@
 
 				case DDSP_REMOVE_BUSSTOP: {
 					TileArea ta(start_tile, end_tile);
-					DoCommandP(ta.tile, ta.w | ta.h << 8, (_ctrl_pressed << 1) | ROADSTOP_BUS, CMD_REMOVE_ROAD_STOP | CMD_MSG(_road_type_infos[_cur_roadtype].err_remove_station[ROADSTOP_BUS]), CcPlaySound1D);
+					DoCommandP(ta.tile, ta.w | ta.h << 8, ROADSTOP_BUS, CMD_REMOVE_ROAD_STOP | CMD_MSG(_road_type_infos[_cur_roadtype].err_remove_station[ROADSTOP_BUS]), CcPlaySound1D);
 					break;
 				}
 
 				case DDSP_REMOVE_TRUCKSTOP: {
 					TileArea ta(start_tile, end_tile);
-					DoCommandP(ta.tile, ta.w | ta.h << 8, (_ctrl_pressed << 1) | ROADSTOP_TRUCK, CMD_REMOVE_ROAD_STOP | CMD_MSG(_road_type_infos[_cur_roadtype].err_remove_station[ROADSTOP_TRUCK]), CcPlaySound1D);
+					DoCommandP(ta.tile, ta.w | ta.h << 8, ROADSTOP_TRUCK, CMD_REMOVE_ROAD_STOP | CMD_MSG(_road_type_infos[_cur_roadtype].err_remove_station[ROADSTOP_TRUCK]), CcPlaySound1D);
 					break;
 				}
 			}
@@ -706,6 +891,7 @@
 	Hotkey('6', "bus_station", WID_ROT_BUS_STATION),
 	Hotkey('7', "truck_station", WID_ROT_TRUCK_STATION),
 	Hotkey('8', "oneway", WID_ROT_ONE_WAY),
+	Hotkey('9', "fullroad", WID_ROT_FULLROAD),
 	Hotkey('B', "bridge", WID_ROT_BUILD_BRIDGE),
 	Hotkey('T', "tunnel", WID_ROT_BUILD_TUNNEL),
 	Hotkey('R', "remove", WID_ROT_REMOVE),
@@ -738,6 +924,8 @@
 		NWidget(WWT_PANEL, COLOUR_DARK_GREEN, -1), SetMinimalSize(0, 22), SetFill(1, 1), EndContainer(),
 		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, WID_ROT_ONE_WAY),
 						SetFill(0, 1), SetMinimalSize(22, 22), SetDataTip(SPR_IMG_ROAD_ONE_WAY, STR_ROAD_TOOLBAR_TOOLTIP_TOGGLE_ONE_WAY_ROAD),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, WID_ROT_FULLROAD),
+						SetFill(0, 1), SetMinimalSize(22, 22), SetDataTip(SPR_IMG_AUTOROAD, STR_ROAD_TOOLBAR_TOOLTIP_BUILD_FULLROAD),
 		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, WID_ROT_BUILD_BRIDGE),
 						SetFill(0, 1), SetMinimalSize(43, 22), SetDataTip(SPR_IMG_BRIDGE, STR_ROAD_TOOLBAR_TOOLTIP_BUILD_ROAD_BRIDGE),
 		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, WID_ROT_BUILD_TUNNEL),
@@ -864,7 +1052,7 @@
 		this->LowerWidget(_road_depot_orientation + WID_BROD_DEPOT_NE);
 		if ( _cur_roadtype == ROADTYPE_TRAM) {
 			this->GetWidget<NWidgetCore>(WID_BROD_CAPTION)->widget_data = STR_BUILD_DEPOT_TRAM_ORIENTATION_CAPTION;
-			for (int i = WID_BROD_DEPOT_NE; i <= WID_BROD_DEPOT_NW; i++) this->GetWidget<NWidgetCore>(i)->tool_tip = STR_BUILD_DEPOT_TRAM_ORIENTATION_SELECT_TOOLTIP;
+			for (int i = WID_BROD_DEPOT_NE; i <= WID_BROD_DEPOT_AUTO; i++) this->GetWidget<NWidgetCore>(i)->tool_tip = STR_BUILD_DEPOT_TRAM_ORIENTATION_SELECT_TOOLTIP;
 		}
 
 		this->FinishInitNested(TRANSPORT_ROAD);
@@ -872,10 +1060,20 @@
 
 	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
 	{
-		if (!IsInsideMM(widget, WID_BROD_DEPOT_NE, WID_BROD_DEPOT_NW + 1)) return;
-
-		size->width  = ScaleGUITrad(64) + 2;
-		size->height = ScaleGUITrad(48) + 2;
+		switch (widget) {
+			case WID_BROD_DEPOT_NW:
+			case WID_BROD_DEPOT_NE:
+			case WID_BROD_DEPOT_SW:
+			case WID_BROD_DEPOT_SE:
+				size->width  = ScaleGUITrad(64) + 2;
+				size->height = ScaleGUITrad(48) + 2;
+				break;
+			case WID_BROD_DEPOT_AUTO:
+				size->width = ScaleGUITrad(128) + 6;
+				break;
+			default:
+				break;
+		}
 	}
 
 	virtual void DrawWidget(const Rect &r, int widget) const
@@ -892,6 +1090,7 @@
 			case WID_BROD_DEPOT_NE:
 			case WID_BROD_DEPOT_SW:
 			case WID_BROD_DEPOT_SE:
+			case WID_BROD_DEPOT_AUTO:
 				this->RaiseWidget(_road_depot_orientation + WID_BROD_DEPOT_NE);
 				_road_depot_orientation = (DiagDirection)(widget - WID_BROD_DEPOT_NE);
 				this->LowerWidget(_road_depot_orientation + WID_BROD_DEPOT_NE);
@@ -931,6 +1130,12 @@
 			EndContainer(),
 			NWidget(NWID_SPACER), SetMinimalSize(3, 0), SetFill(1, 0),
 		EndContainer(),
+		NWidget(NWID_SPACER), SetMinimalSize(0, 2),
+		NWidget(NWID_HORIZONTAL), SetPIP(2, 2, 2),
+			NWidget(NWID_SPACER), SetFill(1, 0),
+			NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_BROD_DEPOT_AUTO), SetMinimalSize(134, 12), SetDataTip(STR_STATION_BUILD_ORIENTATION_AUTO, STR_BUILD_DEPOT_ROAD_ORIENTATION_AUTO_TOOLTIP),
+			NWidget(NWID_SPACER), SetFill(1, 0),
+		EndContainer(),
 		NWidget(NWID_SPACER), SetMinimalSize(0, 3),
 	EndContainer(),
 };
@@ -1008,10 +1213,25 @@
 
 	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
 	{
-		if (!IsInsideMM(widget, WID_BROS_STATION_NE, WID_BROS_STATION_Y + 1)) return;
-
-		size->width  = ScaleGUITrad(64) + 2;
-		size->height = ScaleGUITrad(48) + 2;
+		switch (widget) {
+			case WID_BROS_STATION_NE:
+			case WID_BROS_STATION_SE:
+			case WID_BROS_STATION_SW:
+			case WID_BROS_STATION_NW:
+			case WID_BROS_STATION_X:
+			case WID_BROS_STATION_Y:
+				size->width  = ScaleGUITrad(64) + 2;
+				size->height = ScaleGUITrad(48) + 2;
+				break;
+			case WID_BROS_STATION_AUTO:
+				size->width  = ScaleGUITrad(128) + 6;
+				break;
+			case WID_BROS_STATION_XY_AUTO:
+				size->width  = ScaleGUITrad(64) + 2;
+				break;
+			default:
+				break;
+		}
 	}
 
 	virtual void DrawWidget(const Rect &r, int widget) const
@@ -1031,6 +1251,8 @@
 			case WID_BROS_STATION_NW:
 			case WID_BROS_STATION_X:
 			case WID_BROS_STATION_Y:
+			case WID_BROS_STATION_AUTO:
+			case WID_BROS_STATION_XY_AUTO:
 				this->RaiseWidget(_road_station_picker_orientation + WID_BROS_STATION_NE);
 				_road_station_picker_orientation = (DiagDirection)(widget - WID_BROS_STATION_NE);
 				this->LowerWidget(_road_station_picker_orientation + WID_BROS_STATION_NE);
@@ -1082,6 +1304,13 @@
 			NWidget(WWT_PANEL, COLOUR_GREY, WID_BROS_STATION_Y),  SetMinimalSize(66, 50), EndContainer(),
 			NWidget(NWID_SPACER), SetFill(1, 0),
 		EndContainer(),
+		NWidget(NWID_SPACER), SetMinimalSize(0, 2),
+		NWidget(NWID_HORIZONTAL), SetPIP(0, 2, 0),
+			NWidget(NWID_SPACER), SetFill(1, 0),
+			NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_BROS_STATION_AUTO), SetMinimalSize(134, 12), SetDataTip(STR_STATION_BUILD_ORIENTATION_AUTO, STR_STATION_BUILD_ORIENTATION_AUTO_TOOLTIP),
+			NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_BROS_STATION_XY_AUTO), SetMinimalSize(66, 12), SetDataTip(STR_STATION_BUILD_ORIENTATION_AUTO, STR_STATION_BUILD_ORIENTATION_AUTO_TOOLTIP),
+			NWidget(NWID_SPACER), SetFill(1, 0),
+		EndContainer(),
 		NWidget(NWID_SPACER), SetMinimalSize(0, 1),
 		NWidget(NWID_HORIZONTAL), SetPIP(2, 0, 2),
 			NWidget(WWT_LABEL, COLOUR_DARK_GREEN, WID_BROS_INFO), SetMinimalSize(140, 14), SetDataTip(STR_STATION_BUILD_COVERAGE_AREA_TITLE, STR_NULL),
@@ -1113,6 +1342,6 @@
 
 void InitializeRoadGui()
 {
-	_road_depot_orientation = DIAGDIR_NW;
-	_road_station_picker_orientation = DIAGDIR_NW;
+	_road_depot_orientation = (DiagDirection)(DIAGDIR_NW + 1);
+	_road_station_picker_orientation = (DiagDirection)(DIAGDIR_END + 3);
 }
diff -r e16bdc0054ce src/saveload/citymania_sl.cpp
--- /dev/null
+++ b/src/saveload/citymania_sl.cpp
@@ -0,0 +1,260 @@
+#include "citymania_sl.h"
+#include "../bitstream.h"
+#include "../date_func.h"
+#include "../debug.h"
+#include "../town.h"
+
+#define CM_DATA_FORMAT_VERSION 1
+
+assert_compile(NUM_CARGO == 32);
+
+
+static void CM_EncodeTownsExtraInfo(BitOStream &bs)
+{
+	Town *t;
+	uint n_affected_towns = 0;
+	FOR_ALL_TOWNS(t) {
+		if (t->growing_by_chance || t->houses_reconstruction ||
+				t->houses_demolished)
+			n_affected_towns++;
+	}
+	bs.WriteBytes(n_affected_towns, 2);
+	FOR_ALL_TOWNS(t) {
+		if (t->growing_by_chance || t->houses_reconstruction ||
+				t->houses_demolished) {
+			bs.WriteBytes(t->index, 2);
+			bs.WriteBytes(t->growing_by_chance, 1);
+			bs.WriteBytes(t->houses_reconstruction, 2);
+			bs.WriteBytes(t->houses_demolished, 2);
+		}
+	}
+}
+
+static void CM_EncodeTownsGrowthTiles(BitOStream &bs, TownsGrowthTilesIndex &tiles)
+{
+	bs.WriteBytes(tiles.size(), 4);
+	for (TownsGrowthTilesIndex::iterator p = tiles.begin();
+			p != tiles.end(); p++) {
+		bs.WriteBytes(p->first, 4);
+		bs.WriteBytes(p->second, 1);
+	}
+}
+
+static void CM_EncodeTownsLayoutErrors(BitOStream &bs)
+{
+	Town *t;
+	uint n_affected_towns = 0;
+	FOR_ALL_TOWNS(t) {
+		if (t->cb_houses_removed || t->houses_skipped || t->cycles_skipped)
+			n_affected_towns++;
+	}
+	bs.WriteBytes(n_affected_towns, 2);
+	FOR_ALL_TOWNS(t) {
+		if (t->cb_houses_removed || t->houses_skipped || t->cycles_skipped) {
+			bs.WriteBytes(t->index, 2);
+			bs.WriteBytes(t->houses_skipped, 2);
+			bs.WriteBytes(t->houses_skipped_prev, 2);
+			bs.WriteBytes(t->houses_skipped_last_month, 2);
+			bs.WriteBytes(t->cycles_skipped, 2);
+			bs.WriteBytes(t->cycles_skipped_prev, 2);
+			bs.WriteBytes(t->cycles_skipped_last_month, 2);
+			bs.WriteBytes(t->cb_houses_removed, 2);
+			bs.WriteBytes(t->cb_houses_removed_prev, 2);
+			bs.WriteBytes(t->cb_houses_removed_last_month, 2);
+		}
+	}
+	CM_EncodeTownsGrowthTiles(bs, _towns_growth_tiles);
+	CM_EncodeTownsGrowthTiles(bs, _towns_growth_tiles_last_month);
+}
+
+static void CM_EncodeTownsCargo(BitOStream &bs)
+{
+	uint n_cb_cargos = 0;
+	CargoID cb_cargos[NUM_CARGO];
+	for(CargoID cargo = 0; cargo < NUM_CARGO; cargo++) {
+		if (CB_GetReq(cargo) > 0)
+			cb_cargos[n_cb_cargos++] = cargo;
+	}
+
+	bs.WriteBytes(CB_GetStorage(), 1);
+	bs.WriteBytes(_settings_client.gui.cb_distance_check, 1);
+	bs.WriteBytes(n_cb_cargos, 1);
+	for (uint i = 0; i < n_cb_cargos; i++) {
+		CargoID cargo = cb_cargos[i];
+		bs.WriteBytes(cargo, 1);
+		bs.WriteBytes(CB_GetReq(cargo), 4);
+		bs.WriteBytes(CB_GetFrom(cargo), 4);
+		bs.WriteBytes(CB_GetDecay(cargo), 1);
+	}
+
+	Town *t;
+	bs.WriteBytes(Town::GetNumItems(), 2);
+	FOR_ALL_TOWNS(t) {
+		bs.WriteBytes(t->index, 2);
+		for (uint i = 0; i < n_cb_cargos; i++) {
+			CargoID cargo = cb_cargos[i];
+			bs.WriteBytes(t->storage[cargo], 4);
+			bs.WriteBytes(t->act_cargo[cargo], 4);
+			bs.WriteBytes(t->new_act_cargo[cargo], 4);
+			bs.WriteBytes(t->delivered_enough[cargo], 1);
+		}
+	}
+}
+
+static void CM_DecodeTownsExtraInfo(BitIStream &bs)
+{
+	Town *t;
+	uint n_affected_towns = bs.ReadBytes(2);
+	for (uint i = 0; i < n_affected_towns; i++) {
+		uint town_id = bs.ReadBytes(2);
+		t = Town::Get(town_id);
+		// TODO is it even supposed to return null? or just invalid pointer
+		if (!t) {
+			DEBUG(sl, 0, "Invalid TownID in CM extra towns info (%u)", town_id);
+			continue;
+		}
+		t->growing_by_chance = bs.ReadBytes(1);
+		t->houses_reconstruction = bs.ReadBytes(2);
+		t->houses_demolished = bs.ReadBytes(2);
+	}
+}
+
+static void CM_DecodeTownsGrowthTiles(BitIStream &bs, TownsGrowthTilesIndex &tiles)
+{
+	uint n = bs.ReadBytes(4);
+	for (uint i = 0; i < n; i++) {
+		TileIndex tile = bs.ReadBytes(4);
+		TownGrowthTileState state = (TownGrowthTileState)bs.ReadBytes(1);
+		tiles[tile] = state;
+	}
+}
+
+static void CM_DecodeTownsLayoutErrors(BitIStream &bs)
+{
+	Town *t;
+	uint n_affected_towns = bs.ReadBytes(2);
+	for (uint i = 0; i < n_affected_towns; i++) {
+		uint town_id = bs.ReadBytes(2);
+		t = Town::Get(town_id);
+		if (!t) {
+			DEBUG(sl, 0, "Invalid TownID in CB towns layout errors (%u)", town_id);
+			continue;
+		}
+		t->houses_skipped = bs.ReadBytes(2);
+		t->houses_skipped_prev = bs.ReadBytes(2);
+		t->houses_skipped_last_month = bs.ReadBytes(2);
+		t->cycles_skipped = bs.ReadBytes(2);
+		t->cycles_skipped_prev = bs.ReadBytes(2);
+		t->cycles_skipped_last_month = bs.ReadBytes(2);
+		t->cb_houses_removed = bs.ReadBytes(2);
+		t->cb_houses_removed_prev = bs.ReadBytes(2);
+		t->cb_houses_removed_last_month = bs.ReadBytes(2);
+	}
+	CM_DecodeTownsGrowthTiles(bs, _towns_growth_tiles);
+	CM_DecodeTownsGrowthTiles(bs, _towns_growth_tiles_last_month);
+}
+
+static void CM_DecodeTownsCargo(BitIStream &bs)
+{
+	CB_SetStorage(bs.ReadBytes(1));
+	_settings_client.gui.cb_distance_check = bs.ReadBytes(1);
+	uint n_cb_cargos = bs.ReadBytes(1);
+	CB_ResetRequirements();
+	CargoID cb_cargos[NUM_CARGO];
+	for (uint i = 0; i < n_cb_cargos; i++) {
+		uint cargo = bs.ReadBytes(1);
+		if (cargo >= NUM_CARGO) {
+			DEBUG(sl, 0, "Invalid CargoID in CB towns cargo data (%u)", cargo);
+			return;
+		}
+		cb_cargos[i] = cargo;
+		uint req = bs.ReadBytes(4);
+		uint from = bs.ReadBytes(4);
+		uint decay = bs.ReadBytes(1);
+		CB_SetRequirements(cargo, req, from, decay);
+	}
+	Town *t;
+	uint n_affected_towns = bs.ReadBytes(2);
+	for (uint i = 0; i < n_affected_towns; i++) {
+		uint town_id = bs.ReadBytes(2);
+		t = Town::Get(town_id);
+		if (!t) {
+			DEBUG(sl, 0, "Invalid TownID in CB towns cargo data (%u)", town_id);
+			continue;
+		}
+		for (uint i = 0; i < n_cb_cargos; i++) {
+			CargoID cargo = cb_cargos[i];
+			t->storage[cargo] = bs.ReadBytes(4);
+			t->act_cargo[cargo] = bs.ReadBytes(4);
+			t->new_act_cargo[cargo] = bs.ReadBytes(4);
+			t->delivered_enough[cargo] = bs.ReadBytes(1);
+		}
+	}
+}
+
+u8vector CM_EncodeData()
+{
+	BitOStream bs;
+	bs.Reserve(1000);
+	bs.WriteBytes(CM_DATA_FORMAT_VERSION, 2);
+	bs.WriteBytes(1512, 2);  // TODO client version
+	bs.WriteBytes(CB_Enabled(), 1);
+	bs.WriteBytes(_date, 4);  // Just in case we'll need to detect that game
+	bs.WriteBytes(_date_fract, 1);  // was saved by unmodified client
+	bs.WriteBytes(0, 4);  // Reserved
+	bs.WriteBytes(0, 4);  // Reserved
+
+	if (CB_Enabled()) CM_EncodeTownsCargo(bs);
+	CM_EncodeTownsExtraInfo(bs);
+	CM_EncodeTownsLayoutErrors(bs);
+
+	// fill with 0 to fit in persistent storage chunks (16 * 4)
+	int mod = bs.GetByteSize() % 64;
+	if (mod) {
+		for (int i = 0; i < 64 - mod; i++)
+			bs.WriteBytes(0, 1);
+	}
+	DEBUG(sl, 2, "Citybuilder data takes %u bytes", bs.GetByteSize());
+	return bs.GetVector();
+}
+
+void CM_DecodeData(u8vector &data)
+{
+	ResetTownsGrowthTiles();
+	extern bool _novahost;
+	if (data.size() == 0) {
+		_novahost = false;
+		CB_SetCB(false);
+		DEBUG(sl, 2, "No citybuilder data");
+		return;
+	}
+	DEBUG(sl, 2, "Citybuilder data takes %lu bytes", data.size());
+	_novahost = true;
+	BitIStream bs(data);
+	try {
+		uint version = bs.ReadBytes(2);
+		if (version != CM_DATA_FORMAT_VERSION) {
+			DEBUG(sl, 0, "Savegame was made with different version of client, extra citybuilder data was not loaded");
+			return;
+		}
+		bs.ReadBytes(2);  // client version
+		bool is_cb = bs.ReadBytes(1);
+		CB_SetCB(is_cb);
+		int32 date = bs.ReadBytes(4);  // date
+		uint32 date_fract = bs.ReadBytes(1);  // date_fract
+		if (date != _date || date_fract != _date_fract) {
+			DEBUG(sl, 0, "Savegame was run in unmodified client, extra cb data "
+			      "preserved, but may not be accurate");
+		}
+		bs.ReadBytes(4);  // reserved
+		bs.ReadBytes(4);  // reserved
+		if (is_cb) {
+			CM_DecodeTownsCargo(bs);
+		}
+		CM_DecodeTownsExtraInfo(bs);
+		CM_DecodeTownsLayoutErrors(bs);
+	}
+	catch (BitIStreamUnexpectedEnd &e) {
+		DEBUG(sl, 0, "Invalid citybuilder data");
+	}
+}
\ No newline at end of file
diff -r e16bdc0054ce src/saveload/citymania_sl.h
--- /dev/null
+++ b/src/saveload/citymania_sl.h
@@ -0,0 +1,9 @@
+#ifndef SAVELOAD_CITYMANIA_SL_H
+#define SAVELOAD_CITYMANIA_SL_H
+
+#include "../bitstream.h"
+
+u8vector CM_EncodeData();
+void CM_DecodeData(u8vector &data);
+
+#endif
diff -r e16bdc0054ce src/saveload/storage_sl.cpp
--- a/src/saveload/storage_sl.cpp
+++ b/src/saveload/storage_sl.cpp
@@ -11,10 +11,14 @@
 
 #include "../stdafx.h"
 #include "../newgrf_storage.h"
+#include "citymania_sl.h"
 #include "saveload.h"
 
 #include "../safeguards.h"
 
+// Luukland_Citybuilder grf id actually
+#define CITYMANIA_GRFID 0x534B0501U
+
 /** Description of the data to save and load in #PersistentStorage. */
 static const SaveLoad _storage_desc[] = {
 	 SLE_CONDVAR(PersistentStorage, grfid,    SLE_UINT32,                  6, SL_MAX_VERSION),
@@ -22,15 +26,62 @@
 	 SLE_END()
 };
 
+// static void hexdump(uint8 *data) {
+// 	uint i;
+// 	for (i = 0; i < 20; i++) {
+// 		if (i) fprintf(stderr, " : ");
+// 		fprintf(stderr, "%02x", data[i]);
+// 	}
+// 	fprintf(stderr, i >= 20 ? " ...\n" : "\n");
+// }
+
 /** Load persistent storage data. */
 static void Load_PSAC()
 {
 	int index;
 
+	/*
+		CITYMANIA_GRFID is used to hide extra data in persitant storages.
+		To save a bit of memory we only keep at most one PS with this
+		grfid and it is later discarded on save.
+	*/
+	PersistentStorage *ps = NULL;
+	u8vector cmdata;
+
 	while ((index = SlIterateArray()) != -1) {
-		assert(PersistentStorage::CanAllocateItem());
-		PersistentStorage *ps = new (index) PersistentStorage(0, 0, 0);
+		if (ps == NULL) {
+			assert(PersistentStorage::CanAllocateItem());
+			ps = new (index) PersistentStorage(0, 0, 0);
+		}
 		SlObject(ps, _storage_desc);
+
+		if (ps->grfid == CITYMANIA_GRFID) {
+			uint8 *data = (uint8 *)(ps->storage);
+			cmdata.insert(cmdata.end(), data, data + 64);
+		} else {
+			ps = NULL;
+		}
+	}
+
+	CM_DecodeData(cmdata);
+}
+
+static void Save_CMDataAsPSAC() {
+	uint32 grfid = CITYMANIA_GRFID;
+	u8vector data = CM_EncodeData();
+	uint8 *ptr = &data[0];
+	SaveLoadGlobVarList _desc[] = {
+		SLEG_CONDVAR(grfid, SLE_UINT32,       6, SL_MAX_VERSION),
+		SLEG_CONDARR(*ptr, SLE_UINT32, 16, 161, SL_MAX_VERSION),
+		SLEG_END()
+	};
+	uint index = PersistentStorage::GetNumItems();
+
+	int n_chunks = data.size() / 64;
+	for (int i = 0; i < n_chunks; i++, ptr += 64) {
+		_desc[1].address = (void *)ptr;
+		SlSetArrayIndex(index + i);
+		SlGlobList(_desc);
 	}
 }
 
@@ -41,10 +92,15 @@
 
 	/* Write the industries */
 	FOR_ALL_STORAGES(ps) {
+		if (ps->grfid == CITYMANIA_GRFID) {
+			continue;
+		}
 		ps->ClearChanges();
 		SlSetArrayIndex(ps->index);
 		SlObject(ps, _storage_desc);
 	}
+
+	Save_CMDataAsPSAC();
 }
 
 /** Chunk handler for persistent storages. */
diff -r e16bdc0054ce src/saveload/town_sl.cpp
--- a/src/saveload/town_sl.cpp
+++ b/src/saveload/town_sl.cpp
@@ -32,6 +32,7 @@
 	FOR_ALL_TOWNS(town) {
 		town->cache.population = 0;
 		town->cache.num_houses = 0;
+		town->cache.potential_pop = 0;
 	}
 
 	for (TileIndex t = 0; t < MapSize(); t++) {
@@ -41,6 +42,8 @@
 		town = Town::GetByTile(t);
 		IncreaseBuildingCount(town, house_id);
 		if (IsHouseCompleted(t)) town->cache.population += HouseSpec::Get(house_id)->population;
+		else town->houses_construction++;
+		town->cache.potential_pop += HouseSpec::Get(house_id)->population;
 
 		/* Increase the number of houses for every house, but only once. */
 		if (GetHouseNorthPart(house_id) == 0) town->cache.num_houses++;
